import { select, arc } from 'd3';

const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

const g = svg
  .append('g')
  .attr(
    'transform',
    `translate(${width / 2}, ${height / 2})`,
  );

const face = g.append('circle');

face.attr('r', height / 2);
face.attr('fill', 'gray');
face.attr('stroke', 'blue');

const eyeSpacing = 88;
const eyeYOffset = -50;
const eyeRadiusX = 35;
const eyeRadiusY = 35;
const eyebrowWidth = 90;
const eyebrowHeight = 10;
const eyebrowYOffset = -67;

const eyesG = g
  .append('g')
  .attr('transform', `translate(0, ${eyeYOffset})`);

const eyebrowsG = eyesG
  .append('g')
  .attr(
    'transform',
    `translate(0, ${eyebrowYOffset}) rotate(-10)`,
  );

const LeyebrowsG = eyesG
  .append('g')
  .attr(
    'transform',
    `translate(0, ${eyebrowYOffset}) rotate(10)`,
  );

LeyebrowsG.append('rect')
  .attr('x', -eyeSpacing - eyebrowWidth / 2)
  .attr('y', -eyebrowHeight / 3)
  .attr('width', eyebrowWidth)
  .attr('height', eyebrowHeight);

eyebrowsG
  .append('rect')
  .attr('x', eyeSpacing - eyebrowWidth / 2)
  .attr('y', -eyebrowHeight / 2)
  .attr('width', eyebrowWidth)
  .attr('height', eyebrowHeight);

const mouth = g
  .append('path')
  .attr(
    'd',
    arc()({
      innerRadius: 70,
      outerRadius: 80,
      startAngle: Math.PI / 2,
      endAngle: (Math.PI * 3) / 2,
    }),
  )
  .attr('fill', 'black')
  .attr('transform', `translate(0, ${55})`);


const mustacheLength = 25;
const mustacheWidth = 3;


const mustache1 = g
  .append('line')
  .attr('x1', -30)
  .attr('y1', 50)
  .attr('x2', -30 + mustacheLength)
  .attr('y2', 45)
  .attr('stroke', 'black')
  .attr('stroke-width', mustacheWidth);

const mustache2 = g
  .append('line')
  .attr('x1', -30)
  .attr('y1', 55)
  .attr('x2', -30 + mustacheLength)
  .attr('y2', 55)
  .attr('stroke', 'black')
  .attr('stroke-width', mustacheWidth);

const mustache3 = g
  .append('line')
  .attr('x1', -30)
  .attr('y1', 60)
  .attr('x2', -30 + mustacheLength)
  .attr('y2', 65)
  .attr('stroke', 'black')
  .attr('stroke-width', mustacheWidth);

// Mustache on the left side of the mouth
const mustache4 = g
  .append('line')
  .attr('x1', 30)
  .attr('y1', 50)
  .attr('x2', 30 - mustacheLength)
  .attr('y2', 45)
  .attr('stroke', 'black')
  .attr('stroke-width', mustacheWidth);

const mustache5 = g
  .append('line')
  .attr('x1', 30)
  .attr('y1', 55)
  .attr('x2', 30 - mustacheLength)
  .attr('y2', 55)
  .attr('stroke', 'black')
  .attr('stroke-width', mustacheWidth);

const mustache6 = g
  .append('line')
  .attr('x1', 30)
  .attr('y1', 60)
  .attr('x2', 30 - mustacheLength)
  .attr('y2', 65)
  .attr('stroke', 'black')
  .attr('stroke-width', mustacheWidth);

const earRadius = 40;
let earCenterX = -width / 4.7;
const earCenterY = -height / 2 + 30;

const leftEar = g
  .append('path')
  .attr(
    'd',
    `M ${earCenterX},${earCenterY} A ${earRadius},${earRadius} 0 0,0 ${earCenterX + 2 * earRadius},${earCenterY}`,
  )
  .attr('fill', 'gray');
earCenterX = -width / 8;
const rightEar = g
  .append('path')
  .attr(
    'd',
    `M ${-earCenterX},${earCenterY} A ${earRadius},${earRadius} 0 0,0 ${-earCenterX + 2 * earRadius},${earCenterY}`,
  )
  .attr('fill', 'gray');
